#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Walapa Muangjeen
#===============================================================================

#version:
#4.0.264 - version update

import re
import common as cf

class aligner(object):

	cfg = {
		'version': '4.0.264',
		}
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.newkey = {}
		self.regex = {}
		self.regex['zh_hk'] = re.compile(u"“(.*?)”( |)\((.*?)\)")
		self.regex['en']    = re.compile(u"\"(.*?)\"( |)\((.*?)\)")
		self.a = ( u'( \(|\()', u'(\)\*|\)|\) )' )
		self.b = {}
		self.b['zh_hk'] = ( u'”、“', u'”和“' )
		self.b['en']    = ( u'', u'' )
		self.z = {}
		self.z['zh_hk'] = ( u'”、“', '', u', ' )
		self.z['en']    = ( u'" and "','' , u'、' )

	def run(self,ktgt):
		'''run filter'''

		ksrc = list(ktgt)
		ksrc[cf.rdrlang] = ktgt[cf.srclang]
		ksrc = tuple(ksrc)

		newfilelist = list(self.p.cfoutput[ksrc]['filelist'])
		newfilelist[cf.kind] = newfilelist[cf.kind] + '-dictionary'
		self.newkey[(ktgt[cf.srclang],ktgt[cf.srclang])] = tuple(newfilelist[cf.stage+1:])

		newfilelist = list(self.p.cfoutput[ktgt]['filelist'])
		newfilelist[cf.kind] = newfilelist[cf.kind] + '-dictionary'
		self.newkey[(ktgt[cf.srclang],ktgt[cf.rdrlang])] = tuple(newfilelist[cf.stage+1:])

		newfilelist = list(self.p.cfoutput[ktgt]['filelist'])
		newfilelist[cf.kind] = newfilelist[cf.kind] + '-dictionary'
		newfilelist[cf.srclang] = ktgt[cf.rdrlang]
		self.newkey[(ktgt[cf.rdrlang],ktgt[cf.rdrlang])] = tuple(newfilelist[cf.stage+1:])

		newfilelist = list(self.p.cfoutput[ksrc]['filelist'])
		newfilelist[cf.kind] = newfilelist[cf.kind] + '-dictionary'
		newfilelist[cf.srclang] = ktgt[cf.rdrlang]
		self.newkey[(ktgt[cf.rdrlang],ktgt[cf.srclang])] = tuple(newfilelist[cf.stage+1:])

		for linenum in range(len(self.p.cfoutput[ktgt]['tempbuff'])):
			self.p.cfoutput[ktgt]['tempbuff'][linenum] = self.__filter(self.p.cfoutput[ktgt]['tempbuff'][linenum], linenum, ktgt, ktgt[cf.rdrlang])
			self.p.cfoutput[ksrc]['tempbuff'][linenum] = self.__filter(self.p.cfoutput[ksrc]['tempbuff'][linenum], linenum, ktgt, ktgt[cf.srclang])

		self.p.writer.run(self.p.cfextract)
		self.p.writer.flush(self.p.cfextract)

	def flush(self,ktgt):
		return

	def close(self):
		return

	def __filter(self,text,linenum,ktgt,lang):
		'''extract dictionary'''
		results = re.findall(self.regex[lang], text)
		for found in results:
			for lefttxt in found[0].split(self.z[lang][0]):
				for righttxt in found[2].split(self.z[lang][2]):
					if lang == ktgt[cf.srclang]:
						self.p.cfoutput[self.newkey[(ktgt[cf.srclang],ktgt[cf.srclang])]]['tempbuff'].append(lefttxt)
						self.p.cfoutput[self.newkey[(ktgt[cf.srclang],ktgt[cf.rdrlang])]]['tempbuff'].append(righttxt)
					else:
						self.p.cfoutput[self.newkey[(ktgt[cf.rdrlang],ktgt[cf.srclang])]]['tempbuff'].append(righttxt)
						self.p.cfoutput[self.newkey[(ktgt[cf.rdrlang],ktgt[cf.rdrlang])]]['tempbuff'].append(lefttxt)
					text = re.sub(self.a[0] + found[2] + self.a[1], '', text)
					text = re.sub(self.b[lang][0], self.b[lang][1], text)
		return text

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filtergraph\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''CorpusFiltergraph™ v4.0
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
