#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Tom Hoar
#===============================================================================

#version:
#4.0.264 - version update

from copy import deepcopy
import common as cf

class aligner(object):

	cfg = {
		'deletecopy': True,
		'linksource': True,
		'version': '4.0.264',
		}
	deletecopy = True,
	linksource = True,
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.deletecopy = cfg['deletecopy']
		self.linksource = cfg['linksource']

	def run(self,ktgt):
		'''run filter'''
		self.p.cfoutput[ktgt]['tempbuff'] = deepcopy(self.p.cfextract[ktgt]['tempbuff'])
		if self.deletecopy:
			self.p.cfextract[ktgt]['tempbuff'] = ['' for line in self.p.cfextract[ktgt]['tempbuff']]
		if self.linksource:
			ksrc = list(ktgt)
			ksrc[cf.rdrlang] = ktgt[cf.srclang]
			ksrc = tuple(ksrc)
			self.p.cfoutput[ksrc]['tempbuff'] = deepcopy(self.p.cfextract[ksrc]['tempbuff'])
			if self.deletecopy:
				self.p.cfextract[ksrc]['tempbuff'] = ['' for line in self.p.cfextract[ksrc]['tempbuff']]

	def flush(self,ktgt):
		return

	def close(self):
		return

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filter\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''CorpusFiltergraph™ v4.0
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
