#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Walapa Muangjeen
#===============================================================================

#version:
#4.0.264 - version update

import os
import sys
import common as cf
import logging

logger = logging.getLogger('.'.join([os.path.splitext(os.path.basename(sys.argv[0]))[0],'manager','filtergraph',__name__]))
skipclose = True

class filter(object):

	cfg = {
		'encoding': 'utf8',
		'inputfile': '',
		'outputfile': '',
		'version': '4.0.264',
		}
	encoding = 'utf8'
	inputfile = ''
	outputfile = ''
	replace = {
#		u'″': u'"',
#		u'−': u'-',
		u'　': u' ',
		u'！': u'!',
		u'＃': u'#',
		u'＄': u'$',
		u'％': u'%',
		u'＆': u'&',
		u'（': u'(',
		u'）': u')',
		u'＊': u'*',
		u'＋': u'+',
		u'．': u'.',
		u'／': u'/',
		u'０': u'0',
		u'１': u'1',
		u'２': u'2',
		u'３': u'3',
		u'４': u'4',
		u'５': u'5',
		u'６': u'6',
		u'７': u'7',
		u'８': u'8',
		u'９': u'9',
		u'；': u';',
		u'＝': u'=',
		u'＞': u'>',
		u'？': u'?',
		u'＠': u'@',
		u'Ａ': u'A',
		u'Ｂ': u'B',
		u'Ｃ': u'C',
		u'Ｄ': u'D',
		u'Ｅ': u'E',
		u'Ｆ': u'F',
		u'Ｇ': u'G',
		u'Ｈ': u'H',
		u'Ｉ': u'I',
		u'Ｊ': u'J',
		u'Ｋ': u'K',
		u'Ｌ': u'L',
		u'Ｍ': u'M',
		u'Ｎ': u'N',
		u'Ｏ': u'O',
		u'Ｐ': u'P',
		u'Ｑ': u'Q',
		u'Ｒ': u'R',
		u'Ｓ': u'S',
		u'Ｔ': u'T',
		u'Ｕ': u'U',
		u'Ｖ': u'V',
		u'Ｗ': u'W',
		u'Ｘ': u'X',
		u'Ｙ': u'Y',
		u'Ｚ': u'Z',
		u'［': u'u',
		u'＼': u'\\',
		u'］': u']',
		u'＾': u'^',
		u'＿': u'_',
		u'ａ': u'a',
		u'ｂ': u'b',
		u'ｃ': u'c',
		u'ｄ': u'd',
		u'ｅ': u'e',
		u'ｆ': u'f',
		u'ｇ': u'g',
		u'ｈ': u'h',
		u'ｉ': u'i',
		u'ｊ': u'j',
		u'ｋ': u'k',
		u'ｌ': u'l',
		u'ｍ': u'm',
		u'ｎ': u'n',
		u'ｏ': u'o',
		u'ｐ': u'p',
		u'ｑ': u'q',
		u'ｒ': u'r',
		u'ｓ': u's',
		u'ｔ': u't',
		u'ｕ': u'u',
		u'ｖ': u'v',
		u'ｗ': u'w',
		u'ｘ': u'x',
		u'ｙ': u'y',
		u'ｚ': u'z',
		u'｛': u'{',
		u'｜': u'|',
		u'｝': u'}',
#		u'･': u'∙',
#		u'ﾟ': u'°',
#		u'￣': u'¯',
		u'｢': u'「',
		u'｣': u'」',
		u'￥': u'¥',
		}
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.encoding = 'utf8' if 'utf8' in cfg['encoding'].lower().replace('-','') else cfg['encoding']
		self.inputfile = cfg['inputfile'].replace('%(rootfolder)s',parent.rootfolder) if cfg['inputfile'] else self.inputfile
		self.outputfile = cfg['outputfile'].replace('%(rootfolder)s',parent.rootfolder) if cfg['outputfile'] else self.outputfile
		if (self.inputfile and not self.outputfile) or (not self.inputfile and self.outputfile):
			self.errors.append([__name__,'invalid','[%s] inputfile=%s without outputfile= value'%(__name__,cfg['inputfile'])])
			logger.warn('%s\t%s',*self.errors[-1][1:])

	def run(self,k):
		global skipclose
		skipclose = not self.inputfile
		if self.inputfile: return

		self.p.cfoutput[k]['tempbuff'] = [self.__filter(line) for line in self.p.cfoutput[k]['tempbuff']]

	def flush(self,k):
		return

	def close(self):
		if skipclose: return

		import os
		import sys
		import codecs

		if not os.path.exists(self.inputfile):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.inputfile)])
			logger.error('%s\t%s',*self.errors[-1][1:])
			return

		# make output folder
		try:
			os.makedirs(os.path.dirname(self.outputfile))
		except OSError,e:
			if not e.errno == 17:
				logger.exception('%s\t%s, %s, %s',*['failed',e.errno,e.strerror,e.filename,])
				raise OSError(e)

		# open input and output files
		out = self.outputfile
		if out == self.inputfile:
			import tempfile
			fd,out = tempfile.mkstemp(suffix='.tmp', prefix='~', dir=self.p.tempdir)
			os.close(fd)
		try:
			o = codecs.open(out,'w',self.encoding)
			i = codecs.open(self.inputfile,'r',self.encoding)
		except:
			raise RuntimeError('Failed to open [%s] input/output files'%(__name__))

		sys.stderr.write('[%s] %s\n   Please wait'%(__name__,self.outputfile))
		cnt = 0
		try:
			# loop writes output line-by-line

			if self.exceptions:
				for line in i:
					o.write('%s\n'%(u''.join([ch if ch in self.exception else unicodedata.normalize(self.form,ch) for ch in '\b'.join(line.rstrip('\r\n')).split('\b')])))
					cnt += 1
					if not cnt%5000: sys.stderr.write('.')
			else:
				for line in i:
					o.write('%s\n'%(self.__filter(line.rstrip('\r\n'))))
					cnt += 1
					if not cnt%5000: sys.stderr.write('.')

			sys.stderr.write('\n')
			# close input and output files
			i.close()
			o.close()

			if not out == self.outputfile:
				import shutil
				shutil.move(out,self.outputfile)

		except KeyboardInterrupt:
			os.unlink(out)
			raise KeyboardInterrupt()

		if not os.path.exists(self.outputfile):
			self.errors.append([__name__,'missing','[%s] %s'%(__name__,self.outputfile)])
			logger.error('%s\t%s',*self.errors[-1][1:])

	def __filter(self,text):
		'''Normalize JA english charactors to western UTF-8 range'''
		for i, j in self.replace.items():
			text = text.replace(i, j)
		return text

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import filter\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''CorpusFiltergraph™ v4.0
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
