#! /usr/bin/env python
# -*- coding: utf8 -*-

#===============================================================================
# Author: Tom Hoar
#===============================================================================

#version:
#4.0.264 - version update

import codecs
import common as cf

class filter(object):

	cfg = {
		'append': False,
		'encoding': 'utf8',
		'eol': 'linux',
		'rendertype': '',
		'saveastm': False,
		'version': '4.0.264',
		}
	append = False
	encoding = 'utf8'
	eol = '\x0a'
	rendertype = ''
	saveastm = False
	isopen = False
	p = object
	errors = []

	def open(self,parent,cfg):
		self.append = 'a' if self.cfg['append'] else 'w'
		self.cfextract = self.p.CustomExtract()
		self.encoding = 'utf8' if 'utf8' in self.cfg['encoding'].lower().replace('-','') else self.cfg['encoding']
		self.eol = '\x0d\x0a' if cfg['eol'].lower() == 'win' else '\x0a'
		self.rendertype = cfg['rendertype']
		self.saveastm = cfg['saveastm']

	def run(self,k):
		'''saves buffer to file'''
		if not sum([ len(line.strip()) for line in self.p.cfoutput[k]['tempbuff'] ]): return

		if self.saveastm:
			knew = list(k)
			if self.saveastm: knew[cf.kind] = knew[cf.kind].replace(u'lm',u'tm',1)
			knew = tuple(knew)
		else:
			knew = k

		if not self.cfextract[knew]['lock']: return -2
		self.cfextract[knew]['tempbuff'] = list(self.p.cfoutput[k]['tempbuff'])
		try:
			codecs.open(self.cfextract[knew]['tempname'],self.append,self.encoding).write(self.eol.join(self.cfextract[knew]['tempbuff'])+self.eol)
		except Exception,e:
			return -2
		else:
			ext = self.p.writer.rendertypes
			self.p.writer.rendertypes = self.rendertype
			self.p.writer.flush(self.cfextract,knew)
			self.p.writer.rendertypes = ext

	def flush(self,k):
		return

	def close(self):
		return

def usage():
	'''Command prompt help.'''
	return "\n%s\n\tUsage:\n\tfrom %s import reader\n"%(
	os.path.basename(sys.argv[0]),
	os.path.splitext(os.path.basename(sys.argv[0]))[0]
	)

licensetxt=u'''CorpusFiltergraph™ v4.0
Copyright © 2010-2012 Precision Translation Tools Co., Ltd.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see http://www.gnu.org/licenses/.

For more information, please contact Precision Translation Tools Co., Ltd.
at: http://www.precisiontranslationtools.com'''

if __name__ == "__main__":
	import os
	import sys
	sys.stdout.write(usage().encode('utf8')+'\n')
